'stonegame by PaPi 12-25-2007 ( ! )
'there are 2 files as resource in the same folder as this source file:
'				20stone.bmp and stonegame.ico
'and the file PaPi_routines_101.lib which must be in same folder as fnxcompiler.exe etc.

uses PaPi_routines_101
resource TwentyStone as "20stone.bmp"
dim ko(9) as integer,  num(11,11) as integer, ido as double,ut as single
object myform as form
	autosize=true
	center=true
	caption=ProgramName(Appname$) 
	onActivate=ProgInit
	object menu0 as mainmenu
		object menu1 as menuitem
			caption="Game"
			object menu1_1 as menuitem
				caption="New Game"
				onclick=newboard
			end object
			object menu1_2 as menuitem
				caption="Exit Game"
				onclick=ExitProg
			end object
		end object ' menu1
		object menu2 as menuitem
			caption="Help"
			object menu2_1 as menuitem
				caption="Rules"
				onclick=Rules_text
			end object
			object menu2_2 as menuitem
				caption="About"
				onclick=About_text
			end object
		end object 'menu2
	end object
	object container as image
		autosize=true
		bmpresource(TwentyStone)
		visible=false
	end object ' container
	object board as image
		left=0:top=0:width=12*36:height=12*36
		onmouseup=clicking
	end object ' board
	object pb as progressbar
		smooth=true
		left=2 :top=12*36+2:width=12*36 : height=20
		min=0:max=100
	end object ' pb	
end object ' myform
myform.ShowModal

'-------------------------------------------------------------
sub kkkk(z1 as integer,z2 as integer,k1 as integer,k2 as integer)
	k1=z1:k2=z2
	if k1>k2 then swap k1,k2
end sub ' kkkk
'-------------------------------------------------------------
function free_path(i1 as integer,j1 as integer,i2 as integer,j2 as integer) as boolean
dim k1 as integer,k2 as integer
result=true
' if the 2 stones are in single row or single column:
if  i1 = i2  or j1 = j2  then
	result=free_line(i1,j1,i2,j2)
	if result=true then exit sub
end if
' if the 2 stones interconnected along the edge:
result=false
if free_line(i1,0,i1,j1)=true and free_line(i2,0,i2,j2)=true then result=true ' free path to left
if free_line(i1,j1,i1,11)=true and free_line(i2,j2,i2,11)=true then result=true '  free path to right
if free_line(0,j1,i1,j1)=true and free_line(0,j2,i2,j2)=true then result=true '  free path to up
if free_line(i1,j1,11,j1)=true and free_line(i2,j2,11,j2)=true then result=true ' free path to below

end function ' free_path
'-------------------------------------------------------------
function free_line(i1 as integer,j1 as integer,i2 as integer,j2 as integer) as boolean
	dim b as boolean, i as integer, j as integer,k1 as integer,k2 as integer
	b=false
	if i1=i2 then ' the 2 stones are in single column
		b=true
		if abs(j2-j1)>1 then
			kkkk(j1,j2,k1,k2)
			for j=k1+1 to k2-1 
				if num(i1,j)<>0 then b=false
			next j
		end if
	end if
	if j1=j2 then ' the 2 stones are in single row

		b=true
		if abs(i2-i1)>1 then
			kkkk(i1,i2,k1,k2)
			for i=k1+1 to k2-1 
				if num(i,j1)<>0 then b=false
			next i
		end if
	end if
	result=b
end function ' free_lineer
'-------------------------------------------------------------
sub clicking(but as integer,x as integer,y as integer)
	dim i as integer,j as integer,k as integer
	click_work(x,y)
	k=0
	for i=1 to 10
		for j=1 to 10
			if num(i,j)=0 then k=k+1
		next j
	next i
	pb.position=k
	if k=0 then ido=timer
	if k=100 then 
		ido=timer-ido
		showmessage "Congratulation:     "+mezo(ut/ido*100,0)+" %" 
'	ut = sum distances of 2 stones in all step (in divisions)
'   ido = the all time of solution
	end if
end sub ' clicking
'-------------------------------------------------------------
sub click_work(x as integer,y as integer)
	dim i as integer,j as integer,van as integer
	dim i0 as integer,j0 as integer
	i0=int(x/36) : j0=int(y/36) : van=0
	if num(i0,j0)=0 then exit sub
		if num(i0,j0) > 0 then
			for i=1 to 10
				for j=1 to 10
					if num(i,j)<0 then
						van=van+1
						if  abs(num(i,j)) = abs(num(i0,j0))  and van=1  and free_path(i,j,i0,j0)=true then
							removing(i,j)
							removing(i0,j0)
							van=0
							ut=ut+sqr((i0-i)^2+(j0-j)^2)
						end if
						exit sub
					end if
				next j
			next i
		end if
	brillance_change(board,i0,j0)
end sub ' click_work
'-------------------------------------------------------------
sub removing(i0 as integer,j0 as integer)
	board.fillrect(i0*36,j0*36,(i0+1)*36,(j0+1)*36,&hFFFFFF)
	framing(i0,j0)
	num(i0,j0)=0
end sub ' removing
'-------------------------------------------------------------
sub brillance_change(what as image,i0 as integer,j0 as integer)
	Image_copy(container,(abs(num(i0,j0))-1)*36,18*(1+sgn(num(i0,j0))),36,36,board,(i0)*36,(j0)*36)
	num(i0,j0)=-num(i0,j0)
	framing(i0,j0)
end sub ' brillance_change
'-------------------------------------------------------------
sub ProgInit()
	setparent(myform.hwnd)
	appicon "stonegame.ico"
	newboard()
end sub ' proginit
'-------------------------------------------------------------
sub newboard()
	dim i as integer,j as integer,k as integer
	for i=0 to 11
		if i<10 then ko(i)=0
		for j=0 to 11
			num(i,j)=0
		next j
	next i
	for i=0 to 9
		for j=0 to 9
			k=shuffle()+1
			num(i+1,j+1)=k
			Image_copy(container,(k-1)*36,0,36,36,board,(i+1)*36,(j+1)*36)			
		next j
	next i
	for i=0 to 11
		for j=0 to 11
			framing(i,j)
		next j
	next i
	ut=0
end sub ' newboard
'-------------------------------------------------------------
sub Image_copy(what as image,i1 as integer,j1 as integer,ni as integer,nj as integer,whither as image,hi1 as integer,hj1 as integer)
	dim i as integer,j as integer
	for i=i1 to i1+ni-1
		for j=j1 to j1+nj-1
			whither.pset(hi1+i-i1,hj1+j-j1,what.peek(i,j))
		next j
	next i
end sub ' Image_copy
'-------------------------------------------------------------
sub framing(i as integer,j as integer)
		board.RoundRect(i*36,j*36,(i+1)*36,(j+1)*36,6,6,0)
end sub ' torles
'-------------------------------------------------------------
function shuffle() as integer
	dim m as integer,z as boolean
	z=true
	while z=true
		m=rnd(10)
		if ko(m)<10 then
			z=false
			ko(m)=ko(m)+1
			result=m
			exit sub
		end if
	wend
end function ' shuffle
'-------------------------------------------------------------
sub Rules_text()
	dim RT as string
	RT="Rules of game:"+CRLF+"Clear the board by clicking on two matching stones, that"
	RT=RT+CRLF+"can be connected by a line, or, three lines with two some sideward bends." 
	showmessage RT
end sub ' Rules_text
'-------------------------------------------------------------
sub About_text()
	dim AT as string
	AT="This game is a simplistic version of a notorious classic game "
	AT=AT+CRLF+"as programming training for me.  (PaPi)
	showmessage AT
end sub ' About_text